%{?mingw_package_header}

%define name1 drmingw

Name:           mingw-%{name1}
Version:        0.9.2
Release:        1%{?dist}
Summary:        Just-in-Time (JIT) debugger for MinGW

License:        LGPLv2+
URL:            https://github.com/jrfonseca/%{name1}
Source0:        https://github.com/jrfonseca/%{name1}/archive/%{version}.tar.gz
# use system instead of bundled zlib
Patch0:         drmingw-unbundlezlib.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  mingw32-filesystem
BuildRequires:  mingw64-filesystem
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw64-binutils
BuildRequires:  mingw32-libsigc++20
BuildRequires:  mingw64-libsigc++20
BuildRequires:  mingw32-glibmm24
BuildRequires:  mingw64-glibmm24
BuildRequires:  mingw32-wpcap
BuildRequires:  mingw64-wpcap
BuildRequires:  mingw32-zlib
BuildRequires:  mingw64-zlib
BuildRequires:  cmake
BuildArch:      noarch

%description
Dr. Mingw is a Just-in-Time (JIT) debugger. When the application
throws an unhandled exception, Dr. Mingw attaches itself to the
application and collects information about the exception, using the
available debugging information.

Dr. Mingw can read debugging information in DWARF format -- generated
by the Gnu C/C++ Compiler, and in a PDB file -- generated by the
Microsoft Visual C++ Compiler. It relies upon the DbgHelp library to
resolve symbols in modules compiled by the Microsoft tools.

The functionality to resolve symbols and dump stack backtraces is
provided as DLLs so it can be embedded on your applications/tools.

# Win32
%package -n mingw32-%{name1}
Summary:        Just-in-Time (JIT) debugger for MinGW

%description -n mingw32-%{name1}
Dr. Mingw is a Just-in-Time (JIT) debugger. When the application
throws an unhandled exception, Dr. Mingw attaches itself to the
application and collects information about the exception, using the
available debugging information.

Dr. Mingw can read debugging information in DWARF format -- generated
by the Gnu C/C++ Compiler, and in a PDB file -- generated by the
Microsoft Visual C++ Compiler. It relies upon the DbgHelp library to
resolve symbols in modules compiled by the Microsoft tools.

The functionality to resolve symbols and dump stack backtraces is
provided as DLLs so it can be embedded on your applications/tools.

%package -n mingw32-%{name1}-devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       mingw32-%{name1} = %{version}-%{release}

%description -n mingw32-%{name1}-devel
The mingw32-%{name1}-devel package contains libraries and header files for
developing applications that use mingw32-%{name1}.

# Win64
%package -n mingw64-%{name1}
Summary:        Just-in-Time (JIT) debugger for MinGW

%description -n mingw64-%{name1}
Dr. Mingw is a Just-in-Time (JIT) debugger. When the application
throws an unhandled exception, Dr. Mingw attaches itself to the
application and collects information about the exception, using the
available debugging information.

Dr. Mingw can read debugging information in DWARF format -- generated
by the Gnu C/C++ Compiler, and in a PDB file -- generated by the
Microsoft Visual C++ Compiler. It relies upon the DbgHelp library to
resolve symbols in modules compiled by the Microsoft tools.

The functionality to resolve symbols and dump stack backtraces is
provided as DLLs so it can be embedded on your applications/tools.

%package -n mingw64-%{name1}-devel
Summary:        Development files for %{name}
Group:          Development/Libraries
Requires:       mingw64-%{name1} = %{version}-%{release}

%description -n mingw64-%{name1}-devel
The mingw64-%{name1}-devel package contains libraries and header files for
developing applications that use mingw64-%{name1}.

%{?mingw_debug_package}

%prep
%autosetup -n %{name1}-%{version}

%build
%{mingw_cmake}
%{mingw_make} %{?_smp_mflags}


%install
install -d $RPM_BUILD_ROOT%{mingw32_bindir}
install -d $RPM_BUILD_ROOT%{mingw32_libdir}
install -d $RPM_BUILD_ROOT%{mingw32_includedir}
install -p build_win32/bin/addr2line.exe $RPM_BUILD_ROOT%{mingw32_bindir}
install -p build_win32/bin/catchsegv.exe $RPM_BUILD_ROOT%{mingw32_bindir}
install -p build_win32/bin/drmingw.exe $RPM_BUILD_ROOT%{mingw32_bindir}
install -p build_win32/bin/exchndl.dll $RPM_BUILD_ROOT%{mingw32_bindir}
install -p build_win32/bin/mgwhelp.dll $RPM_BUILD_ROOT%{mingw32_bindir}
install -p build_win32/lib/libexchndl.a $RPM_BUILD_ROOT%{mingw32_libdir}
install -p build_win32/lib/libmgwhelp.a $RPM_BUILD_ROOT%{mingw32_libdir}
install -p include/exchndl.h $RPM_BUILD_ROOT%{mingw32_includedir}
chmod a-x $RPM_BUILD_ROOT%{mingw32_libdir}/* $RPM_BUILD_ROOT%{mingw32_includedir}/*
install -d $RPM_BUILD_ROOT%{mingw64_bindir}
install -d $RPM_BUILD_ROOT%{mingw64_libdir}
install -d $RPM_BUILD_ROOT%{mingw64_includedir}
install -p build_win64/bin/addr2line.exe $RPM_BUILD_ROOT%{mingw64_bindir}
install -p build_win64/bin/catchsegv.exe $RPM_BUILD_ROOT%{mingw64_bindir}
install -p build_win64/bin/drmingw.exe $RPM_BUILD_ROOT%{mingw64_bindir}
install -p build_win64/bin/exchndl.dll $RPM_BUILD_ROOT%{mingw64_bindir}
install -p build_win64/bin/mgwhelp.dll $RPM_BUILD_ROOT%{mingw64_bindir}
install -p build_win64/lib/libexchndl.a $RPM_BUILD_ROOT%{mingw64_libdir}
install -p build_win64/lib/libmgwhelp.a $RPM_BUILD_ROOT%{mingw64_libdir}
install -p include/exchndl.h $RPM_BUILD_ROOT%{mingw64_includedir}
chmod a-x $RPM_BUILD_ROOT%{mingw64_libdir}/* $RPM_BUILD_ROOT%{mingw64_includedir}/*

%clean
rm -rf $RPM_BUILD_ROOT

# Win32
%files -n mingw32-%{name1}
%license LICENSE.txt
%doc README.md TODO.md
%{mingw32_bindir}/addr2line.exe
%{mingw32_bindir}/catchsegv.exe
%{mingw32_bindir}/drmingw.exe
%{mingw32_bindir}/exchndl.dll
%{mingw32_bindir}/mgwhelp.dll

%files -n mingw32-%{name1}-devel
%{mingw32_libdir}/libexchndl.a
%{mingw32_libdir}/libmgwhelp.a
%{mingw32_includedir}/exchndl.h

# Win64
%files -n mingw64-%{name1}
%license LICENSE.txt
%doc README.md TODO.md
%{mingw64_bindir}/addr2line.exe
%{mingw64_bindir}/catchsegv.exe
%{mingw64_bindir}/drmingw.exe
%{mingw64_bindir}/exchndl.dll
%{mingw64_bindir}/mgwhelp.dll

%files -n mingw64-%{name1}-devel
%{mingw64_libdir}/libexchndl.a
%{mingw64_libdir}/libmgwhelp.a
%{mingw64_includedir}/exchndl.h

%changelog
* Fri Jul 10 2020 Thomas Sailer <t.sailer@alumni.ethz.ch> - 0.9.2-1
- update to 0.9.2

* Tue Sep 22 2015 Thomas Sailer <t.sailer@alumni.ethz.ch> - 0.7.6-1
- initial specfile
